# User API

## asdf Package

asdf: Python library for reading and writing Advanced Scientific Data Format (ASDF) files

### Functions

`open`(fd[, uri, mode, validate_checksums, …]) | Open an existing ASDF file.
`test`([package, test_path, args, plugins, …]) | Run the tests using pytest.

### Classes

`AsdfFile`([tree, uri, extensions, version, …]) | The main class that represents an ASDF file object.
`CustomType` | Base class for all user-defined types.
`AsdfExtension` | Abstract base class defining an extension to ASDF.
`Stream`(shape, dtype[, strides]) | Used to put a streamed array into the tree.
`IntegerType`(value[, storage_type]) | Enables the storage of arbitrarily large integer values
`ExternalArrayReference`(fileuri, target, …) | Store a reference to an array in an external File.

### Class Inheritance Diagram